// Gen_tbar.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "gen.h"
#include "resource.h"
#include "frontend.h"
#include "titleinfo.h"

const char szAppName[] = "Titlebar Info";

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 ) {
    return TRUE;
}

void config();
void quit();
int init();

winampGeneralPurposePlugin plugin = {
	GPPHDR_VER,
	"",
	init,
	config,
	quit,
};

void config() {
	MessageBox(plugin.hwndParent,
		"Titlebar Info Winamp Plugin version 1.2\n"
		"Copyright  1999-2000, Jos van den Oever\n"
		"Visit homepage at http://www.fenk.wau.nl/~oever/\n"
		"Based on Notify CD Player by Mats Ljungqvist (mlt@cyberdude.com)\n"
		"Converted to plugin by Safai Ma (tfma@hotmail.com)\n",
		szAppName, MB_OK|MB_TOPMOST);
	//DialogBox(plugin.hwndParent, MAKEINTRESOURCE(IDD_ABOUT), NULL, (DLGPROC)AboutDlgProc);
}

void quit() {
}

void getSongName(char * const szWindowTitle, const unsigned int bufsize) {
	char *http = "http://";
	char *winamp = " - Winamp";
	char *mp3 = ".mp3";
	char temp[512];
	char *pos, *pos2, *pos3;
	
	// get the song title
	HWND hwnd = FindWindow("Winamp v1.x",NULL);
	GetWindowText(hwnd, szWindowTitle, bufsize); // bufsize includes '\0'
	// remove silly information
	pos = strstr(szWindowTitle, http);
	if (pos!=NULL) {
		pos2 = pos + strlen(http);
		pos3 = strchr(pos2, '/');
		if (pos3 != NULL) {
			pos2 = pos3+1;
		}
		strcpy(temp, pos2);
		strcpy(szWindowTitle, temp);
	}
	// remove " - Winamp"
	pos = strstr(szWindowTitle, winamp);
	if (pos != NULL) {
		*pos = '\0';
	}
	// remove ".mp3"
	pos = strstr(szWindowTitle, mp3);
	if (pos != NULL) {
		*pos = '\0';
	}
	// remove the song number
	pos = strstr(szWindowTitle, ". ");
	if (pos != NULL) {
		pos2 = pos;
		strcpy(temp, (pos2+2));
		strcpy(szWindowTitle, temp);
	}
	// remove silly mp3 info
	pos = strstr(szWindowTitle, "-/");
	if (pos != NULL) {
		pos2 = pos;
		strcpy(temp, (pos2+2));
		strcpy(szWindowTitle, temp);
	}
}

HANDLE hThread = NULL;
DWORD dwThreadId = 0;

DWORD WINAPI ThreadProc(LPVOID lpParameter) {
	TitleInfo info;
	const unsigned int TEXTLENGTH = 512;
    char szWindowTitle[TEXTLENGTH];

	while (TEXTLENGTH) {
		getSongName(szWindowTitle, TEXTLENGTH);
		info.setText(szWindowTitle);
		info.drawOnCaption();
		Sleep(1000);
	}
	return 0;
}

int init() {
	{
		static char c[512];
		char filename[512],*p;
		GetModuleFileName(plugin.hDllInstance,filename,sizeof(filename));
		p = filename+lstrlen(filename);
		while (p >= filename && *p != '\\') p--;
		wsprintf((plugin.description=c), "%s v1.2 (%s)", szAppName, _strlwr(p+1));
	}

	hThread = CreateThread(NULL, 0, ThreadProc, 0, 0, &dwThreadId);

	return 0;
}

extern "C"
__declspec( dllexport ) winampGeneralPurposePlugin * winampGetGeneralPurposePlugin() {
	return &plugin;
}
